﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Test
{
    public class Ice_Giant : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;
        public Boolean Nullified = false;

        public void Awake()
        {
            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("Fragments/Nope.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(136f,255f,250f, 1f);
            RukaSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();

            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 0f)
                {

                    other.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
                    other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.4f, 0.75f, 0.85f, 1f);
                    other.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                }

            }

        }

        public void FixedUpdate()
        {
            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 0f)
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(175f, 238f, 238f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
                }
                else
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f,1f,0f, 0f);
                }
            }

        }
    }
}
