using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

//I can't express how upsetting it is that this needs a new class
//it's almost the exact same as the magic wand, but since the magic wand is technically a wand, it doesnt have a barrelpostion, so it has to use transform.up
//this wouldnt be a problem if barrelposition wasnt read only >:(
namespace Test
{
    class Test2 : MonoBehaviour
    {
        public string Particle = "Disintegration";

        void Use()
        {

            if (transform.root.localScale.x < 0)
            {
                RaycastHit2D hit = Physics2D.Raycast(GetComponent<CanShoot>().BarrelPosition, -transform.right, LayerMask.GetMask("Objects"));
                if (hit.collider == null) return;
                ModAPI.CreateParticleEffect(Particle, hit.point);

                var allPhysicalChildren = hit.transform.root.GetComponentsInChildren<PhysicalBehaviour>();
                if (allPhysicalChildren.Length == 0) return;
                var consideredWeightless = allPhysicalChildren[0].IsWeightless;

                foreach (var phys in allPhysicalChildren)
                {

                        phys.charge += 50f;
                }
            }
            else
            {
                RaycastHit2D hit = Physics2D.Raycast(GetComponent<CanShoot>().BarrelPosition, transform.right, LayerMask.GetMask("Objects"));
                if (hit.collider == null) return;
                ModAPI.CreateParticleEffect(Particle, hit.point);

                var allPhysicalChildren = hit.transform.root.GetComponentsInChildren<PhysicalBehaviour>();
                if (allPhysicalChildren.Length == 0) return;
                var consideredWeightless = allPhysicalChildren[0].IsWeightless;

                foreach (var phys in allPhysicalChildren)
                {


                        phys.charge += 50f;
                }
            }
        }
    }
}
