﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Test
{
    public class Alien : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;
        public Boolean Nullified = false;

        public void Awake()
        {
            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, -0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("Fragments/werewolfPunch.png", 70f);
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(0.5f, 0.2f, 0.8f, 0f);
            RukaSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
                {

                    other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 2;
                    other.gameObject.GetComponent<LimbBehaviour>().Wince(50f);
                    other.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                }



            }

        }

        public void FixedUpdate()
        {
            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 0f));
                }
                else
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0f);
                }
            }

        }
    }
}
