using System;
using System.Collections;
using System.Runtime.CompilerServices;
using UnityEngine;

// Token: 0x0200011B RID: 283
public abstract class AntiExp : MonoBehaviour
{
    // Token: 0x0600070D RID: 1805 RVA: 0x000258D1 File Offset: 0x00023AD1
    private void Awake()
    {
        this.spriteRenderer = base.GetComponent<SpriteRenderer>();
    }

    // Token: 0x0600070E RID: 1806 RVA: 0x000258DF File Offset: 0x00023ADF
    private void Start()
    {
        if (this.Fingerprint == null || this.Fingerprint.Length == 0)
        {
            this.CreateNewFingerprint();
        }
    }

    // Token: 0x0600070F RID: 1807 RVA: 0x000258F8 File Offset: 0x00023AF8
    private void CreateNewFingerprint()
    {
        this.Fingerprint = new float[64];
        for (int i = 0; i < this.Fingerprint.Length; i++)
        {
            this.Fingerprint[i] = UnityEngine.Random.Range(-1f, 1f);
        }
    }

    // Token: 0x06000710 RID: 1808 RVA: 0x00025958 File Offset: 0x00023B58
    private void Lodged(Stabbing stabbing)
    {
        LimbBehaviour limbBehaviour;
        if (!stabbing.victim.TryGetComponent<LimbBehaviour>(out limbBehaviour))
        {
            return;
        }
        if (!limbBehaviour.GetComponent(this.GetPoisonType()))
        {
            PoisonSpreadBehaviour poisonSpreadBehaviour = limbBehaviour.gameObject.AddComponent(this.GetPoisonType()) as PoisonSpreadBehaviour;
            poisonSpreadBehaviour.Limb = limbBehaviour;
            poisonSpreadBehaviour.Fingerprint = this.Fingerprint;
        }
    }

    // Token: 0x06000711 RID: 1809
    public abstract Type GetPoisonType();

    // Token: 0x06000712 RID: 1810 RVA: 0x000259B0 File Offset: 0x00023BB0
  

    // Token: 0x06000713 RID: 1811 RVA: 0x000259B8 File Offset: 0x00023BB8


    // Token: 0x06000714 RID: 1812 RVA: 0x000259C7 File Offset: 0x00023BC7


    // Token: 0x06000715 RID: 1813 RVA: 0x000259CF File Offset: 0x00023BCF


    // Token: 0x06000716 RID: 1814 RVA: 0x000259D8 File Offset: 0x00023BD8


    // Token: 0x06000718 RID: 1816 RVA: 0x00025A44 File Offset: 0x00023C44
    

    // Token: 0x04000711 RID: 1809
    [HideInInspector]
    public float[] Fingerprint;

    // Token: 0x04000712 RID: 1810
    private SpriteRenderer spriteRenderer;
}
